//                PILATUS のtifファイルからテキストファイルを作成するマクロ
//                PILATUS-300K
//                MakeText.ijm,   by K. Suzuki Niigata University


macro "tif画像からtxt画像作成 " {
  //imgのあるディレクトリdirを指定
  print("処理するフォルダーを指定してください．");
  dir1 = getDirectory("Choose a Directory");
  print(dir1);
  //テキスト画像の保存フォルダーを作る
  dir2=dir1 + "TextImage";
  File.makeDirectory(dir2);
	print("テキスト画像を保存するフォルダー(TextImage)を作成しました．");
  print(dir2);
  
  print("処理する最初のファイルを指定(拡張子も含む)してください．");
  fname=getString("処理最初のファイルを入力", "file_name"); //ファイル名の取得
  
  // ファイル名から 00000.tif の9文字を除いた部分を取り出す．
  length=lengthOf(fname);  //フアイル名の文字数
  
  file_name = substring(fname,0,length-9);	//フアイル名の部分
  suji = substring(fname,length-9,length-4); // 連番部分
  extension = substring(fname,length-4,length);	//拡張子
   print(file_name);
   print(suji);
   print(extension);
  
  st1 = 0;   //処理開始番号
  st1 = parseInt(suji);
  st2 = 100; //処理終了番号
	st2 = getNumber("処理を「終了」する番号を入力",st2);
  // print(st1,st2);
	
	j=0;
  //一括処理の開始 copy+paste
  for (i=st1; i < st2+1; i++) {
    x=""+i;
    number="00000"+x;
    mojisu=lengthOf(number);
    remban=substring(number,mojisu-5,mojisu);
    print(remban);
    newfile =dir1 + "/" + file_name + remban + extension;
            
            open(newfile);
    //run("Brightness/Contrast...");
    setMinAndMax(-10, 200);
    run("Fire");
    
    fname_out="x_" + j;
    file_out = dir2 + "/" + fname_out + ".txt";
    print(file_out);
    saveAs("Text Image", file_out);
    // wait(800);
	close();
		
		j=j+1;
  }
  
}

//  ****************************************************P1h~P2r までのtxt画像を一括作成
macro "P1h~P2r までのtxt画像を一括作成" {
 print("処理する試験片番号のフォルダーを指定してください．");
  dir1 = getDirectory("Choose a Directory");
  print(dir1);
  
  //-------------- -------------------------------- P1hの処理
  //テキスト画像の保存フォルダーを作る
  dir2=dir1 + "P1h/TextImage";
  File.makeDirectory(dir2);
  print("テキスト画像を保存するフォルダー(TextImage)を作成しました．");
  print(dir2);
  
  print("処理する最初のファイルを指定(拡張子も含む)してください．");
  fname=getString("処理最初のファイルを入力", "file_name"); //ファイル名の取得
  
  // ファイル名から 00000.tif の9文字を除いた部分を取り出す．
  length=lengthOf(fname);  //フアイル名の文字数
  
  file_name = substring(fname,0,length-9);	//フアイル名の部分
  suji = substring(fname,length-9,length-4); // 連番部分
  extension = substring(fname,length-4,length);	//拡張子
  print(file_name);
  print(suji);
  print(extension);
  
  st1 = 0;   //処理開始番号
  st1 = parseInt(suji);
  st3 = 100; //処理終了番号
  st3 = getNumber("処理を「終了」する番号を入力",st3);
  // print(st1,st2);
  
  j=0;
  //一括処理の開始 copy+paste
  
  st2=st1+st3
  for (i=st1; i < st2+1; i++) {
    x=""+i;
    number="00000"+x;
    mojisu=lengthOf(number);
    remban=substring(number,mojisu-5,mojisu);
    print(remban);
    newfile =dir1 + "P1h/" + file_name + remban + extension;
    
    open(newfile);
    //run("Brightness/Contrast...");
    setMinAndMax(-10, 200);
    run("Fire");
    
    fname_out="x_" + j;
    file_out = dir2 + "/" + fname_out + ".txt";
    print(file_out);
    saveAs("Text Image", file_out);
    // wait(800);
    close();
    
    j=j+1;
  }
  
  // ----------------------------------------------- P1rの処理
  
  //テキスト画像の保存フォルダーを作る
  
  st1=st2+1;
  st2=st1+st3;
  
  dir2=dir1 + "P1r/TextImage";
  File.makeDirectory(dir2);
  print("テキスト画像を保存するフォルダー(TextImage)を作成しました．");
  print(dir2);
  
  j=0;
  //一括処理の開始 copy+paste
  for (i=st1; i < st2+1; i++) {
    x=""+i;
    number="00000"+x;
    mojisu=lengthOf(number);
    remban=substring(number,mojisu-5,mojisu);
    print(remban);
    newfile =dir1 + "P1r/" + file_name + remban + extension;
    
    open(newfile);
    //run("Brightness/Contrast...");
    setMinAndMax(-10, 200);
    run("Fire");
    
    fname_out="x_" + j;
    file_out = dir2 + "/" + fname_out + ".txt";
    print(file_out);
    saveAs("Text Image", file_out);
    // wait(800);
    close();
    
    j=j+1;
  }
  

  // ----------------------------------------------- P2hの処理
  
  //テキスト画像の保存フォルダーを作る
  
  st1=st2+1;
  st2=st1+st3;
  
  dir2=dir1 + "P2h/TextImage";
  File.makeDirectory(dir2);
  print("テキスト画像を保存するフォルダー(TextImage)を作成しました．");
  print(dir2);
  
  j=0;
  //一括処理の開始 copy+paste
  for (i=st1; i < st2+1; i++) {
    x=""+i;
    number="00000"+x;
    mojisu=lengthOf(number);
    remban=substring(number,mojisu-5,mojisu);
    print(remban);
    newfile =dir1 + "P2h/" + file_name + remban + extension;
    
    open(newfile);
    //run("Brightness/Contrast...");
    setMinAndMax(-10, 200);
    run("Fire");
    
    fname_out="x_" + j;
    file_out = dir2 + "/" + fname_out + ".txt";
    print(file_out);
    saveAs("Text Image", file_out);
    // wait(800);
    close();
    
    j=j+1;
  }
  
  

  // ----------------------------------------------- P2rの処理
  
  //テキスト画像の保存フォルダーを作る
  
  st1=st2+1;
  st2=st1+st3;
  
  dir2=dir1 + "P2r/TextImage";
  File.makeDirectory(dir2);
  print("テキスト画像を保存するフォルダー(TextImage)を作成しました．");
  print(dir2);
  
  j=0;
  //一括処理の開始 copy+paste
  for (i=st1; i < st2+1; i++) {
    x=""+i;
    number="00000"+x;
    mojisu=lengthOf(number);
    remban=substring(number,mojisu-5,mojisu);
    print(remban);
    newfile =dir1 + "P2r/" + file_name + remban + extension;
    
    open(newfile);
    //run("Brightness/Contrast...");
    setMinAndMax(-10, 200);
    run("Fire");
    
    fname_out="x_" + j;
    file_out = dir2 + "/" + fname_out + ".txt";
    print(file_out);
    saveAs("Text Image", file_out);
    // wait(800);
    close();
    
    j=j+1;
  }


}


