# gnuplot_map.bat
# map_stress.f90で出力したgnuplot用の.datファイルから残留応力マップを作図します．
# ターミナルからgnuplotを起動し，load "gnuplot_command.bat"をキーインしてください．

set term 'qt' font "Helvetica,20"
set pm3d map
set xrange[0:37]  
set yrange[-5:5]
set zrange[-50:50]
set xlabel 'x, mm'
set ylabel 'z ,mm'

#   ------------------------------------------------- 周方向-y
set title "Residual stress σh-, MPa"
set palette defined (-50 "blue", 0 "white", 50 "red")
set pm3d interpolate 5, 5
set cbrange[-50:50]
splot 'gnu_s_hm.dat'

pause -1 '改行キーを押すと戻ります．'

#   ------------------------------------------------- 周方向+y
set title "Residual stress σh+, MPa"
set palette defined (-50 "blue", 0 "white", 50 "red")
set pm3d interpolate 5, 5
set cbrange[-50:50]
splot 'gnu_s_hp.dat'
pause -1 '改行キーを押すと戻ります．'

#   ------------------------------------------------- 周方向平均
set title "Residual stress σh, MPa"
set palette defined (-50 "blue", 0 "white", 50 "red")
set pm3d interpolate 5, 5
set cbrange[-50:50]
splot 'gnu_s_h.dat'
pause -1 '改行キーを押すと戻ります．'


#   ------------------------------------------------- 半径方向-y
set title "Residual stress σr-, MPa"
set palette defined (-50 "blue", 0 "white", 50 "red")
set pm3d interpolate 5, 5
set cbrange[-50:50]
splot 'gnu_s_rm.dat'

pause -1 '改行キーを押すと戻ります．'

#   ------------------------------------------------- 半径向+y
set title "Residual stress σr+, MPa"
set palette defined (-50 "blue", 0 "white", 50 "red")
set pm3d interpolate 5, 5
set cbrange[-50:50]
splot 'gnu_s_rp.dat'

pause -1 '改行キーを押すと戻ります．'

#   ------------------------------------------------- 半径方向平均
set title "Residual stress σr, MPa"
set palette defined (-50 "blue", 0 "white", 50 "red")
set pm3d interpolate 5, 5
set cbrange[-50:50]
splot 'gnu_s_r.dat'

pause -1 '改行キーを押すと戻ります．'