!********************************************************************
!*            斑点抽出プログラム    p_spots.f90
!   Kenji Suzuki, Niigata University
!  for PILATUS-300K
!********************************************************************

program p_spots
  implicit none
  
  character:: filename*50,dir1*30,file2*50,mkdir*30
  integer:: i,j,k,l,m,n,w,h,cnt,np,px(200),py(200),sm,nspot
  real*8:: x(0:2000,0:2000),xx(0:2000,0:2000)=0.0
  real*8:: p(0:2000,0:2000)=0.0 !  ピークフィルタの画像
  integer:: bi(0:2000,0:2000)=0 !2値化画像
  integer:: pi(0:2000,0:2000)=0 ,istart, istop, loop
  real*8:: dx(0:2000,0:2000)=0.0,dI(0:2000,0:2000)=0.0,xf,yf,xyf,yxf
  real*8:: s,threshold
  
  
  
  w=486;h=618  ! 画像サイズ                   w=0:486 h=0:618
  m=3   !ピーク抽出セグメントのサイズ全幅 奇数 一般には m=5
  n=(m-1)/2 ! 差分幅
  
  threshold=100.0 ! ピーク検出閾値   この値で斑点検出の閾値を下げると，斑点検出の数が増える
  
    call SYSTEM('ls')
  
    print *,"File x_???.txtの開始番号と停止番号 istart, istopを入力"
    read(5,*) istart, istop
    
  do loop=istart, istop
    write(dir1,'(I5)') loop
    mkdir="mkdir "//trim(adjustl(dir1))
    print *, mkdir
    call SYSTEM(mkdir)   ! ファイル番号のdirの作成

    filename="x_"//trim(adjustl(dir1))//".txt"
    print *,filename
    
  !原画像の読み込み
  open(unit=11,file=filename,status='old')
    do j=0,h
      read(11,*) (x(i,j),i=0,w)
    end do
  close(11)
  
  !配列pの初期化
  do j=0,h
    do i=0,w
      p(i,j)=0.0
    end do
  end do 
  
  !  ピークフィルタ
  do j=1,h-1
    do i=1,w-1
      p(i,j)=4.0*x(i,j)-x(i,j-1)-x(i,j+1)-x(i-1,j)-x(i+1,j)
      if (p(i,j) < threshold) then
        p(i,j) = 0.0
      end if
    end do
  end do
  
  !  ピークフィルタの画像出力
    file2="./"//trim(adjustl(dir1))//"/p.txt"

  open(unit=12,file=file2,status='unknown')
    do j=0,h
      write(12,*) (p(i,j),i=0,w)
    end do
  close(12)
  
    !配列biの初期化
  do j=0,h
    do i=0,w
      bi(i,j)=0
    end do
  end do
  
  do j=1,h-1
    do i=1,w-1
      if (p(i,j) > threshold) then !ピークの周囲を2値化領域指定
         bi(i,j-1)=1 ! bi(i-1,j-1)= 1; bi(i+1,j-1)=1
        bi(i-1,j)= 1; bi(i,j)=1; bi(i+1,j)=1
         bi(i,j+1)=1 ! bi(i-1,j+1)= 1; bi(i+1,j+1)=1
      end if
    end do
  end do
  
    !  2値化画像出力
      file2="./"//trim(adjustl(dir1))//"/bi.txt"
    
  open(unit=12,file=file2,status='unknown')
    do j=0,h
      write(12,*) (bi(i,j),i=0,w)
    end do
  close(12)
  
  
    !  重み画像 pi.txt
    do j=0,h
    do i=0,w
        pi(i,j) = 0  !初期化
    end do
  end do
  
  do j=1,h-1
    do i=1,w-1
      if (bi(i,j) > 0) then
        pi(i,j)=x(i,j)
      end if
    end do
  end do
      !  ピーク位置計算用画像x.txt 出力
      file2="./"//trim(adjustl(dir1))//"/x.txt"
      print *,file2
      
  open(unit=12,file=file2,status='unknown')
    do j=0,h
      write(12,*) (pi(i,j),i=0,w)
    end do
  close(12)
  
  
    ! Labelling ===============================
    call labelling(w,h,nspot,loop)
  
    call centroid(w,h,nspot,loop)
  
  end do ! loop
!---------------------
  120 format(1542f8.1)
  121 format(1542I3)
  
  
end program p_spots


!************************************** ラベリング処理 ********************
subroutine labelling(w,h,m,loop)  !画像の幅w，高さh
  implicit none
  
  character::filename*50,dir1*30
  integer::w,h,i,j,bi(0:2000,0:2000),L(0:2000,0:2000)=0
  integer:: lk(1500) !  look up table
  integer:: label,k,cnt,sn,nos,m,n,ix,iy
  integer:: x(1500,300),y(1500,300) ,lbl(1500), loop
  
  
    !配列pの初期化
  do j=0,h
    do i=0,w
      L(i,j)=0
    end do
  end do
  
  write(dir1,'(I5)') loop
  filename="./"//trim(adjustl(dir1))//"/bi.txt"
  print *,filename
  
  open(unit=11,file=filename,status='old')
    do j=0,h
      read(11,*) (bi(i,j),i=0,w)
    end do
  close(11)
  
  label=0
  do j=1,h-1
    do i=1,w-1
      if(bi(i,j) == 1) then !-------------
      
        if ((L(i,j-1) == 0) .and. (L(i-1,j)==0)) then
          label = label + 1
          L(i,j)=label    ! labelling 
          lk(label)=label ! look up table
        end if
      
        if ((L(i,j-1) .ne. 0).and.(L(i-1,j) == 0)) then
          L(i,j)=L(i,j-1)
        end if
      
        if ((L(i-1,j) .ne. 0).and.(L(i,j-1) == 0)) then
          L(i,j)=L(i-1,j)
        end if
      
        if ((L(i-1,j) .ne. 0).and.(L(i,j-1) .ne. 0)) then
          if(L(i-1,j) > L(i,j-1)) then
            L(i,j)=L(i,j-1)
          else
            L(i,j)=L(i-1,j)
          end if
        end if
      
      end if !-------------------------------
      
    end do
  end do
  
    filename = "./"//trim(adjustl(dir1))//"/tmp.txt"
    
    open(unit=12,file= filename,status='unknown')
    do j=0,h
      write(12,*) (L(i,j),i=0,w)
    end do
  close(12)
  
  ! ------------------------- look up tableの更新 ------------------------

  do j=1,h-1
    do i=1,w-1
      if (L(i,j).ne.0) then
        if ( (L(i,j-1).ne.0) .and. (L(i,j-1) < L(i,j)) ) then
          lk(L(i,j))=L(i,j-1)  
          L(i,j)=L(i,j-1)
        end if
        if ( (L(i+1,j).ne.0) .and. (L(i+1,j) < L(i,j)) ) then
          lk(L(i,j))=L(i+1,j)
          L(i,j)=L(i+1,j)  
        end if
      end if
    end do
  end do
  
  do i=1,label
    print *,i,lk(i)
  end do

  
  do j=1,h-1
    do i=1,w-1
      k=L(i,j) 
      if (k .ne. 0) then
        L(i,j)=lk(k)
      end if

    end do
  end do
  
    filename = "./"//trim(adjustl(dir1))//"/tmp.txt"
  
  open(unit=12,file= filename,status='unknown')
    do j=0,h
      write(12,*) (L(i,j),i=0,w)
    end do
  close(12)

  
  ! output spot data   --------------------------
  
  filename = "./"//trim(adjustl(dir1))//"/tmp.txt"
  
  open (unit=14,file= filename, status="unknown")
  
  m=0
  do k=1,label
    
    sn=lk(k)
    cnt=0;
    
    do j=1,h-1
        do i=1,w-1
            if(L(i,j)==sn) then
              cnt=cnt+1
            end if
        end do
    end do
    
    if (cnt .ne. 0) then
        write(14,*) cnt
        m=m+1
    end if
    
    do j=1,h-1
        do i=1,w-1
            if(L(i,j)==sn) then
              write(14,*) i,j
              L(i,j)=0  !二度出力しないように初期化
            end if
        end do
    end do
    
  end do
  
  close(14)
  
  print *,'Number of spots=',m
    
    filename = "./"//trim(adjustl(dir1))//"/tmp.txt"
    
    open (unit=11,file= filename, status="old")
    do k=1,m
      read(11,*) lbl(k)
      do j=1,lbl(k)
        read(11,*) x(k,j),y(k,j)
      end do
    end do
    close(11)
    
  ! main spot data
    
    filename = "./"//trim(adjustl(dir1))//"/spot.txt"
      
    open (unit=12,file= filename, status="unknown")
    
    write(12,*) m
    do k=1,m
      write(12,*) lbl(k)
      do j=1,lbl(k)
        write(12,*) x(k,j),y(k,j)
      end do
    end do
    close(12)
    
    ! output labelling
    ! initialize Label L
    do j=0,h
      do i=0,w
        L(i,j)=0
      end do
    end do
    
    do i=1,m
     n=lbl(i)
     do j=1,n
      ix= x(i,j) ; iy= y(i,j)
      L(ix,iy)=i
     end do
    end do
  
  filename= "./"//trim(adjustl(dir1))//"/L.txt"
  open (unit=12,file=filename, status="unknown")
    do j=0,h
      write(12,*) (L(i,j),i=0,w)
    end do
  close(12)
  
  
    121 format(1542I4)
end subroutine labelling

! --------------------------- 各斑点の重心計算 ------------------
subroutine centroid(w,h,n,loop)
  implicit none
  
  character::filename*50,dir1*30
  integer:: i,j,k,m,n,w,h,x,y,loop
  real*8::pi(0:2000,0:2000),L(0:2000,0:2000),s,sx,sy,gx(1500),gy(1500)
  integer*4::bi(0:2000,0:2000)
  real*8:: imax

  !  各斑点の重心の計算
  
    write(dir1,'(I5)') loop
  filename= "./"//trim(adjustl(dir1))//"/L.txt"
  print *,filename
  
  open(unit=11,file=filename,status='old')
  
  do j=0,h
    read(11,*) (L(i,j),i=0,w)
  end do
  close(11)
  
  filename= "./"//trim(adjustl(dir1))//"/x.txt"
  open(unit=11,file=filename,status='old')
  
  do j=0,h
    read(11,*) (pi(i,j),i=0,w)
  end do
  close(11)

  do k=1,n
    sx=0.d0; sy=0.d0;s=0.d0
    do j=1,h-1
      do i=1,w-1
        if (L(i,j) == k) then
          sx=sx+pi(i,j)*float(i)
          sy=sy+pi(i,j)*float(j)
          s=s+pi(i,j)
        end if
      end do
    end do
    gx(k)=sx/s; gy(k)=sy/s
    print *,k,gx(k),gy(k)
  end do
  
  ! ------------- 各斑点の重心リストの出力----------------
   filename= "./"//trim(adjustl(dir1))//"/spot_list.txt"
  open(unit=12,file= filename,status='unknown')
    write(12,*) n
    do i=1,n
      write(12,'(I4,2X,F8.2,2X,F8.2)') i,gx(i),gy(i)
    end do
  close(12)
  
  
  ! ------------------ 斑点重心の印字 -----------------
  filename= "./"//trim(adjustl(dir1))//"/x.txt"
  
  open(unit=11,file= filename,status='old')
  
  imax=0.0
  do j=0,h
    read(11,*) (pi(i,j),i=0,w)
  end do
  close(11)
  
  imax=maxval(pi)
  
  do k=1,n
    x=int(gx(k)); y=int(gy(k))
    
    do i=-3,-2
      if ((i+x > 0) .and. (i+y > 0)) then
       pi(i+x,i+y)= imax !左上線
      end if
    end do
    
    do i=2,3
      if ((i+x < w) .and. (i+y < h)) then
       pi(i+x,i+y)= imax !右下線
      end if
    end do
    
    do j=-3,-2
      if ((j+y > 0) .and. (x-j < h)) then
       pi(x-j,j+y)= imax !右上線
      end if
    end do
  
    do j=2,3
      if ((j+y < h) .and. (x-j > 0)) then
       pi(x-j,j+y)= imax !左下線
      end if
    end do
    
  end do

  
  !画素の整数化
  do j=0,h
    do i=0,w
      bi(i,j)=int(pi(i,j))
    end do
  end do 
  
  !重心画像
  filename= "./"//trim(adjustl(dir1))//"/centroid.txt"
  open(unit=12,file=filename,status='unknown')
  do j=0,h
    write(12,*) (bi(i,j),i=0,w)
  end do
  close(12)
  
end subroutine centroid
  
