!**********************************************************
!           vectors.f90    by K.Suzuki
!      メモリーディスクの残留応力のベクトル表示用データ
! splot "e_hp.txt" with vectors linecolor 'red', 
!   "e_hm.txt" with vectors linecolor 'blue'
!
!**********************************************************

program vectors

  implicit none
  
  character:: iii*4
  integer:: i,j,k,l,m,n
  real:: x(10000) = 0.0 ,y(10000) = 0.0 ,z(10000) = 0.0 
  real:: er(10000) = 0.0 ,ey(10000) = 0.0 ,eh(10000) = 0.0 
  real:: tth(10000),pi=3.1415926
  real:: th0_h,th0_r,free2th
  
  
  print *,"vectorsフォルダーのhoop.txtとradial.txtをコピーしてください。"
  print *,"よろしいですか? (yes)"

    read(5,*) iii
!  --------------------         周方向のひずみのベクトル線図

  open(unit = 11, file="hoop.txt", status="old")
  
  read(11,*) free2th
  th0_h= free2th*pi/360.0 
  
  i=0
  do 
    i=i+1
    read(11,*,end=99) j, x(i),y(i),z(i),tth(i)
    z(i)= real(mod(j,11)-5) + z(i)
    x(i)= real(int(j/11))+x(i)
    eh(i)=sin(th0_h)/sin(tth(i)*pi/360.0)-1.0
  end do

99 close(11); n=i
  
  open(unit=12, file="e_hp.txt", status="unknown")
  open(unit=14, file="e_hm.txt", status="unknown")
  
  do i=1,n
  
    if(eh(i) .ge. 0.0) then
      write(12,112) x(i),y(i),z(i), 0.0, 0.0,eh(i)*1.e+4
    else
      write(14,112) x(i),y(i),z(i), 0.0, 0.0,eh(i)*1.e+4
    end if
  end do
  
  close(12);close(14)
  
!  配列の初期化
  do i=1,10000
    x(i)=0.0;y(i)=0.0;z(i)=0.0;er(i)=0.0;ey(i)=0.0;eh(i)=0.0
  end do
  
  !  --------------------         半径方向のひずみのベクトル線図
  
  open(unit = 11, file="radial.txt", status="old")
  
  read(11,*) free2th
  th0_r= free2th*pi/360.0 
  
  i=0
  do 
    i=i+1
    read(11,*,end=98) j, x(i),y(i),z(i),tth(i)
    z(i)= real(mod(j,11)-5) + z(i)
    x(i)= real(int(j/11))+x(i)
    er(i)=sin(th0_r)/sin(tth(i)*pi/360.0)-1.0
  end do
  
98 close(11); n=i
  
  open(unit=12, file="e_rp.txt", status="unknown")
  open(unit=14, file="e_rm.txt", status="unknown")
  
  do i=1,n
  
    if(er(i) .ge. 0.0) then
      write(12,112) x(i),y(i),z(i),er(i)*1.e+4, 0.0, 0.0
    else
      write(14,112) x(i),y(i),z(i),er(i)*1.e+4, 0.0, 0.0
    end if
    
  end do
  
  close(12);close(14)
  


112 format(6(2x,F10.3))
end program vectors