macro "FireMax100_viewer"{
	run("Fire");
	//run("Brightness/Contrast...");
	setMinAndMax(-10, 100);

}

macro "p_spots viewer" {
	//p_spotsで処理したdirを指定
	print("処理するフォルダーを指定してください．");
	dir1 = getDirectory("Choose a Directory");
	
	// ピークフィルタ画像
	xfile= "open=" + dir1 + "p.txt";
	print(xfile);
	run("Text Image... ", xfile);
	
	// ラベリング画像
	xfile= "open=" + dir1 + "L.txt";
	print(xfile);
	run("Text Image... ", xfile);
	
	// 重心画像
	xfile= "open=" + dir1 + "centroid.txt";
	print(xfile);
	run("Text Image... ", xfile);
	
	// 原画像
	xfile= "open=" + dir1 + "x.txt";
	print(xfile);
	run("Text Image... ", xfile);
	
	// 表示処理
	selectImage("x.txt");
	run("Fire");
	setMinAndMax(-10, 200);
	
	selectImage("L.txt");
	run("3-3-2 RGB");
	
	selectImage("p.txt");
	run("Fire");
	setMinAndMax(0, 200);
	
	selectImage("centroid.txt");
	run("Fire");
	setMinAndMax(-10, 100);
}

macro "原画像(tif )のスタック" {
  //imgのあるディレクトリdirを指定
  print("処理するtifのフォルダーを指定してください．");
  dir1 = getDirectory("Choose a Directory");
  print(dir1);
  //テキスト画像の保存フォルダーを作る
  print("処理する最初のファイルを指定(tif拡張子も含む)してください．");
  fname=getString("処理最初のファイルを入力", "file_name"); //ファイル名の取得
  
  // ファイル名から 00000.tif の9文字を除いた部分を取り出す．
  length=lengthOf(fname);  //フアイル名の文字数
  
  file_name = substring(fname,0,length-9);	//フアイル名の部分
  suji = substring(fname,length-9,length-4); // 連番部分
  extension = substring(fname,length-4,length);	//拡張子
   print(file_name);
   print(suji);
   print(extension);
  
  st1 = 0;   //処理開始番号
  st1 = parseInt(suji);
  st2 = 100; //処理終了番号
	st2 = getNumber("処理を「終了」する数字を入力",st2);
  // print(st1,st2);
	
	j=0;
  //一括処理の開始 copy+paste
  for (i=st1; i < st2+1; i++) {
    x=""+i;
    number="00000"+x;
    mojisu=lengthOf(number);
    remban=substring(number,mojisu-5,mojisu);
    print(remban);
    newfile =dir1 + "/" + file_name + remban + extension;

            open(newfile);
    //run("Brightness/Contrast...");
    setMinAndMax(-10, 100);
    run("Fire");
	}
	run("Images to Stack", "name=Stack_tif");

}


macro "x.txtのスタック" {
	print("x.txtのスタックを作成します．");
	print("処理するフォルダーを指定してください．");
	dir1 = getDirectory("Choose a Directory");
	
	for (i=0; i<418; i++){
		
		xfile= "open=" + dir1 + i + "/x.txt";
		print(xfile);
		run("Text Image... ", xfile);
		run("Fire");
		//run("Brightness/Contrast...");
		setMinAndMax(-10, 200);
	}
	run("Images to Stack", "name=Stack_x.txt");
}

macro "L.txtのスタック" {
	print("L.txtのスタックを作成します．");
	print("処理するフォルダーを指定してください．");
	dir1 = getDirectory("Choose a Directory");
	
	for (i=0; i<418; i++){
		
		xfile= "open=" + dir1 + i + "/L.txt";
		print(xfile);
		run("Text Image... ", xfile);
		run("3-3-2 RGB");
		//run("Brightness/Contrast...");
		setMinAndMax(0, 88);
	}
	run("Images to Stack", "name=Stack_L.txt");
}


macro "重心のスタック" {
	print("重心のスタックを作成します．");
	print("処理するフォルダーを指定してください．");
	dir1 = getDirectory("Choose a Directory");
	
	for (i=0; i<418; i++){
		
		xfile= "open=" + dir1 + i + "/centroid.txt";
		print(xfile);
		run("Text Image... ", xfile);
		run("Fire");
		//run("Brightness/Contrast...");
		setMinAndMax(-10, 200);
	}
	run("Images to Stack", "name=Stack_centroid");
}

macro "処理画像のスタックを一括作成" {
	
	//----------------------------- tif画像のスタック作成
	print("処理するフォルダー(tifのある)を指定してください．");
	dir1 = getDirectory("Choose a Directory");
	print(dir1);
	//テキスト画像の保存フォルダーを作る
	print("処理する最初のファイルを指定(拡張子tifも含む)してください．");
	fname=getString("処理最初のファイルを入力", "file_name"); //ファイル名の取得
	
	// ファイル名から 00000.tif の9文字を除いた部分を取り出す．
	length=lengthOf(fname);  //フアイル名の文字数
	
	file_name = substring(fname,0,length-9);	//フアイル名の部分
	suji = substring(fname,length-9,length-4); // 連番部分
	extension = substring(fname,length-4,length);	//拡張子
	print(file_name);
	print(suji);
	print(extension);
	
	st1 = 0;   //処理開始番号
	st1 = parseInt(suji);
	st2 = 100; //処理終了番号
	st2 = getNumber("処理を「終了」する数字を入力",st2);
	// print(st1,st2);
	st3=0;
	st4=st2-st1
	
	j=0;
	//一括処理の開始 copy+paste
	for (i=st1; i < st2+1; i++) {
		x=""+i;
		number="00000"+x;
		mojisu=lengthOf(number);
		remban=substring(number,mojisu-5,mojisu);
		print(remban);
		newfile =dir1 + "/" + file_name + remban + extension;
		
		open(newfile);
		//run("Brightness/Contrast...");
		setMinAndMax(-10, 100);
		run("Fire");
	}
	run("Images to Stack", "name=Stack_tif");
	filename=dir1+"org.tif";
	saveAs("Tiff", filename);
	run("Close All");
	
	
	//---------------- ラベリング像 L.txtのスタックを作成
	print("L.txtのスタックを作成します．");
	
	dir2 = dir1+"TextImage/";
	for (i=st3; i<st4+1; i++){
		
		xfile= "open=" + dir2 + i + "/L.txt";
		print(xfile);
		run("Text Image... ", xfile);
		run("3-3-2 RGB");
		//run("Brightness/Contrast...");
		setMinAndMax(0, 88);
	}
	run("Images to Stack", "name=Stack_L.txt");
	filename=dir1+"L.tif";
	saveAs("Tiff", filename);
	run("Close All");
	
	
	print("重心のスタックを作成します．");
	
	dir2 = dir1+"TextImage/";
	
	for (i=st3; i<st4+1; i++){
		xfile= "open=" + dir2 + i + "/centroid.txt";
		print(xfile);
		run("Text Image... ", xfile);
		run("Fire");
		//run("Brightness/Contrast...");
		setMinAndMax(-10, 200);
	}
	run("Images to Stack", "name=Stack_centroid");
	
	filename=dir1+"centroid.tif";
	saveAs("Tiff", filename);
	run("Close All");
	
}